
//defini le package de la classe Connexion
package doca;
//la classe se trouve donc dans java.awt
import java.awt.Dimension;
//la classe se trouve donc dans java.awt
import java.awt.Toolkit;
//la classe se trouve donc dans java.security
import java.security.MessageDigest;
//la classe se trouve donc dans java.security
import java.security.NoSuchAlgorithmException;
//la classe se trouve donc dans java.sql
import java.sql.Connection;
//la classe se trouve donc dans java.asql
import java.sql.DriverManager;
//la classe se trouve donc dans java.sql
import java.sql.PreparedStatement;
//la classe se trouve donc dans java.sql
import java.sql.ResultSet;
//la classe se trouve donc dans java.sql
import java.sql.SQLException;
//la classe se trouve donc dans java.util.login
import java.util.logging.Level;
//la classe se trouve donc dans java.loggin.logger
import java.util.logging.Logger;
//la classe se trouve donc dans java.Swing.JOptionPane
import javax.swing.JOptionPane;

/**
 *
 * @author JD
 */
public class Connexion extends javax.swing.JDialog {

    /**
     * Creates new form Connexion
     */
    
    //Permet de retourner l'id de l'utilisateur
    String utilisateur;
    
    /*public Connexion(String utilisateur) {
        this.utilisateur = utilisateur;
    }*/

    /**
     *
     */

    public Connexion() {
        
    }

    /**
     *
     * @return
     */
    public String getUtilisateur() {
        return utilisateur;
    }

    /**
     *
     * @param utilisateur
     */
    public void setUtilisateur(String utilisateur) {
        this.utilisateur = utilisateur;
    }
    
    /**
     *
     * @param parent
     * @param modal
     */
    public Connexion(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        // Cette librairie utilise le système graphique de la plate-forme d'exécution (Windows, MacOS, X-Window) pour afficher les objets graphiques
         Toolkit toolkit = getToolkit();
         //toolkit contient des classes décrivant les composants graphiques, les polices, les couleurs et les images.
        Dimension size= toolkit.getScreenSize();
        setLocation(size.width/2-getWidth()/2, size.height/2 -getHeight()/2);
        
    }

   

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">                          
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        username = new javax.swing.JTextField();
        password = new javax.swing.JPasswordField();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        connect = new javax.swing.JButton();
        inscription = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        lbl_username = new javax.swing.JLabel();
        lbl_password = new javax.swing.JLabel();
        exit = new javax.swing.JButton();
        acceuil = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBackground(new java.awt.Color(255, 77, 100));
        jPanel1.setForeground(new java.awt.Color(102, 255, 204));

        username.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                usernameActionPerformed(evt);
            }
        });
        username.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                usernameKeyReleased(evt);
            }
        });

        password.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                passwordActionPerformed(evt);
            }
        });
        password.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                passwordKeyReleased(evt);
            }
        });

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/username.png"))); // NOI18N
        jLabel1.setText("jLabel1");

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/password.png"))); // NOI18N
        jLabel3.setText("jLabel3");

        connect.setText("Se Connecter");
        connect.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                connectMouseClicked(evt);
            }
        });
        connect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connectActionPerformed(evt);
            }
        });

        inscription.setText("S'inscrire");
        inscription.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                inscriptionActionPerformed(evt);
            }
        });

        jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/doca.jpg"))); // NOI18N
        jLabel4.setText("jLabel4");

        exit.setText("EXIT");
        exit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitActionPerformed(evt);
            }
        });

        acceuil.setText("Acceuil");
        acceuil.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                acceuilActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 509, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(98, 98, 98)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(username, javax.swing.GroupLayout.PREFERRED_SIZE, 158, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lbl_username, javax.swing.GroupLayout.PREFERRED_SIZE, 158, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(81, 81, 81)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 136, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(lbl_password, javax.swing.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE)
                                        .addContainerGap())))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(password, javax.swing.GroupLayout.PREFERRED_SIZE, 142, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addContainerGap())))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(251, 251, 251)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(inscription, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(connect, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE))
                        .addContainerGap())))
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(223, 223, 223)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(acceuil, javax.swing.GroupLayout.DEFAULT_SIZE, 96, Short.MAX_VALUE)
                    .addComponent(exit, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(95, 95, 95)
                        .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 476, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(104, 104, 104)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 126, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lbl_username, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lbl_password, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(username, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(password, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(23, 23, 23)
                        .addComponent(connect, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(28, 28, 28)
                        .addComponent(inscription, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 18, 18)
                .addComponent(exit, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(acceuil, javax.swing.GroupLayout.DEFAULT_SIZE, 30, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>                        

    //Partie Connecction
    
    // la connexion de l'utilisateur va permettre l'exécution de l'ensembe des paramètres suivantes:
    private void connectActionPerformed(java.awt.event.ActionEvent evt) {                                        
       
        
        //Condition visant à  l'utilisateur àsaisir obligatoirement ses informations
        //Tant que cette condition n'est pas validé la connexion ne pourra pas se faire
        if(username.getText().trim().trim().isEmpty() && password.getText().trim().trim().isEmpty()){
            
            lbl_username.setText("L'username est vide...");
            lbl_password.setText("Mot de passe est vide...");
        }
        else if(username.getText().trim().isEmpty()){
            lbl_username.setText("L'username est vide...");
    }
         else if(password.getText().trim().isEmpty()){
            lbl_password.setText("Mot de passe est vide...");
    }else{
             
    //Si cette condition est validé:
        
         try {
             //Mesure de sécurité SHA-256 => Cryptage Password
                    MessageDigest md = MessageDigest.getInstance("SHA-256");
                    md.update(password.getText().getBytes());

                    byte byteData[] = md.digest();

                    //convertir le tableau de bits en une format hexadécimal - méthode 1
                    StringBuffer sb = new StringBuffer();
                    for (int i = 0; i < byteData.length; i++) {
                     sb.append(Integer.toString((byteData[i] & 0xff) + 0x100, 16).substring(1));
                    }
                    //Appel du driver JDBC afin de se connecter à la base de donnée "doca"
                    Class.forName("com.mysql.jdbc.Driver");
                    //Chemin vers la base "doca" suivi des paramètre de connexion (utilisateur & mot de passe"
                    Connection con = DriverManager.getConnection("jdbc:mysql://localhost:3306/doca", "root","");
                    //requête SQL afin de vérifier les informations saisit par l'utilisateur
                    String sql = "Select * from users where username=? and password=?";
                    PreparedStatement pst = con.prepareStatement(sql);
                    pst.setString(1, username.getText());
                    pst.setString(2, sb.toString());
                    ResultSet rs = pst.executeQuery();
                    if(rs.next()){
                        //Si les informations  est validé, afficher le message suivante grâce au ShowMessageDialog :
                        setUtilisateur(username.getText()) ;
                        JOptionPane.showMessageDialog(null, "Nom utilisateur et mot de passe Correct");
                        
                        
                       //redirection vers l'interface note:
                        Note notes = new Note(this);
                        notes.setVisible(true);
                        setVisible(false);
                    }
                    
                     else{
                        //dans le cas contraire:
                       
                        JOptionPane.showMessageDialog(null, "Nom utilisateur et mot de passe incorrect");
                        //Refresh des JTEtxFields
                 username.setText("");
                 password.setText("");
                
                        
                 }
                    
                   
                    
                    //System.out.println("Connecter");
                } catch (ClassNotFoundException | SQLException e){
                    JOptionPane.showMessageDialog(null,e);
                } catch (NoSuchAlgorithmException ex) {
                Logger.getLogger(Connexion.class.getName()).log(Level.SEVERE, null, ex);
            }
    }
        

        
        
    }                                       

    //JTextField Username pour que l'utilisateur saisisse son nom d'utilisateur
    private void usernameActionPerformed(java.awt.event.ActionEvent evt) {                                         
        // TODO add your handling code here:
    }                                        

    private void usernameKeyReleased(java.awt.event.KeyEvent evt) {                                     
        // Refresh
        lbl_username.setText("");
    }                                    

    private void passwordKeyReleased(java.awt.event.KeyEvent evt) {                                     
        // Refresh
        lbl_password.setText("");
    }                                    

    private void connectMouseClicked(java.awt.event.MouseEvent evt) {                                     
       
    }                                    

    private void inscriptionActionPerformed(java.awt.event.ActionEvent evt) {                                            
  //Permet d'afficher Jframe.from d'Inscription.java et de fermer simultanément le JframeForm de Inscription.java
                    Inscription inscription = new Inscription();
                    inscription.setVisible(true);
                    setVisible(false);
        
    }                                           
//Bouton EXIT pour pouvoir quitter l'application
    private void exitActionPerformed(java.awt.event.ActionEvent evt) {                                     
        //ferme l'applicaiton
        System.exit(0);
    }                                    
//Bouton Acceuil permettant de revenir sur l'interface de MainMenu.java
    private void acceuilActionPerformed(java.awt.event.ActionEvent evt) {                                        
         //Permet d'afficher Jframe.from d'MainMenu.java et de fermer simultanément le JframeForm de Connexion.java
        MainMenu menu = new MainMenu();
                    setVisible(false);
                    menu.setVisible(true);
    }                                       
//JTextField Password pour que l'utilisateur saisisse son Password
    private void passwordActionPerformed(java.awt.event.ActionEvent evt) {                                         
       
    }                                        

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Connexion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Connexion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Connexion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Connexion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                Connexion dialog = new Connexion(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify                     
    private javax.swing.JButton acceuil;
    private javax.swing.JButton connect;
    private javax.swing.JButton exit;
    private javax.swing.JButton inscription;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel lbl_password;
    private javax.swing.JLabel lbl_username;
    private javax.swing.JPasswordField password;
    private javax.swing.JTextField username;
    // End of variables declaration                   
}
